﻿Type=StaticCode
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private wordMap As Map
	Private defaultLanguage = "en_US" As String
	Private isInitialized = False As Boolean

End Sub

Private Sub Initialize

	If isInitialized = False Then
		
		fillWordMap
		isInitialized = True

	End If

End Sub


Public Sub setLanguage(language As String)
	
	defaultLanguage = language
	
End Sub


Public Sub activity(act As Activity)
		
	' Activity title
	Dim a = act.Title As String
	
	If a.StartsWith("mtr.") Then
		act.Title = get(a.SubString(4))
	End If

	' All the views	
	For Each v As View In act.GetAllViewsRecursive
				
		If v Is AutoCompleteEditText Or v Is Button Or v Is CheckBox Or v Is EditText Or v Is Label Or v Is RadioButton Then

			Dim tmpe As Label
			tmpe = v
			If tmpe.Text.StartsWith("mtr.") Then
				tmpe.Text = get(tmpe.Text.SubString(4))
			End If

		Else If v Is ToggleButton Then

			Dim tmpt As ToggleButton
			tmpt = v
			If tmpt.TextOn.StartsWith("mtr.") Then
				tmpt.TextOn = get(tmpt.TextOn.SubString(4))
			End If

			If tmpt.TextOff.StartsWith("mtr.") Then
				tmpt.TextOff = get(tmpt.TextOff.SubString(4))
			End If

		End If
		
	Next
	
End Sub


Public Sub get(text As String) As String

	Initialize	
	
	Dim params As List
	params.Initialize
	Return get3(text, params, defaultLanguage)

End Sub


Public Sub get2(text As String, params As List) As String
	
	Initialize
	
	Return get3(text, params, defaultLanguage)
	
End Sub


Public Sub get3(text As String, params As List, language As String) As String

	Initialize
	
	Dim key = (text & "." & language) As String
	Dim result As String
	Dim i As Int
	
	If wordMap.ContainsKey(key) Then
		
		result = wordMap.Get(key)
		For i = 0 To params.Size-1
			result = result.Replace("{" & i & "}", params.Get(i))
		Next
		
		Return result
		
	Else

		Log("MTRANS: Missing translation for " & text & "." & language)
		Return "!" & text
		
	End If	
	
End Sub

Private Sub fillWordMap
	
	wordMap.Initialize

	' English
	wordMap.Put("appname.en_US", "MTrans - mini translator helper")
	wordMap.Put("send.en_US", "Send")
	wordMap.Put("greeting.en_US", "Hello sailor!")
	wordMap.Put("signoff.en_US", "Later")
	wordMap.Put("color.en_US", "Pinkish")
	wordMap.Put("receive.en_US", "Receive")
	wordMap.Put("line.en_US", "Line")
	wordMap.Put("off.en_US", "Turned off")
	wordMap.Put("on.en_US", "Turned on")
	wordMap.Put("paramtest.en_US", "Test with params: First came {0}, followed by {1} and finally {2}.")

	' Swedish
	wordMap.Put("appname.sv", "MTrans - en liten översättare")
	wordMap.Put("send.sv", "Skicka")
	wordMap.Put("greeting.sv", "Tjena!")
	wordMap.Put("signoff.sv", "Vi hörs senare")
	wordMap.Put("color.sv", "Rosaaktig")
	wordMap.Put("receive.sv", "Ta emot")
	wordMap.Put("line.sv", "Linje")
	wordMap.Put("off.sv", "Avstängd")
	wordMap.Put("on.sv", "Påslagen")

	' German (only partial, causing fail)
	wordMap.Put("appname.de", "MTrans - Mini-Übersetzer Helfer")
	wordMap.Put("send.de", "Senden")
	wordMap.Put("greeting.de", "Hallo!")
	
End Sub
